/* -*- c++ -*- */
/*
 * Copyright 2009 Einar Thorsrud.
 *
 * This file is part of the GNU Radio DSRC module.
 *
 * The GNU Radio DSRC module is free software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2, or (at your option) any later version.
 *
 * The GNU Radio DSRC module is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the GNU Radio DSRC module; see the file COPYING.  If
 * not, write to the Free Software Foundation, Inc., 51 Franklin
 * Street, Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_DSRC_NRZI_TO_NRZ_BB_H
#define INCLUDED_DSRC_NRZI_TO_NRZ_BB_H

#include <gr_sync_block.h>

class dsrc_nrzi_to_nrz_bb;
typedef boost::shared_ptr<dsrc_nrzi_to_nrz_bb> dsrc_nrzi_to_nrz_bb_sptr;

dsrc_nrzi_to_nrz_bb_sptr dsrc_make_nrzi_to_nrz_bb (bool preload);

/*!
 * \brief Convert NRZI to NRZ. One bit per byte.
 * \ingroup block
 *
 */
class dsrc_nrzi_to_nrz_bb : public gr_sync_block
{
  friend dsrc_nrzi_to_nrz_bb_sptr dsrc_make_nrzi_to_nrz_bb (bool preload);
  dsrc_nrzi_to_nrz_bb (bool preload); // private constructor

  unsigned char d_prev_nrzi_bit;

 public:
  int work (int                       noutput_items,
            gr_vector_const_void_star &input_items,
            gr_vector_void_star       &output_items);
};

#endif
